<?php if (!defined('APPLICATION')) exit();

$PluginInfo['CookiePop'] = array(
   'Description' => 'A popup opens for every visitor who comes to the site for the first time to inform of the use of cookies.',
   'Version' => '1.1',
   'SettingsUrl' => '/plugin/CookiePop',
   'SettingsPermission' => 'Garden.Settings.Manage',
   'Author' => "VrijVlinder",
   'License'=>"GNU GPL2"
);

class CookiePopPlugin extends Gdn_Plugin {


   public function __construct() {
      
   }
   

	public function Base_AfterBody_Handler($Sender) {
   //GET THE CONFIGURATION VALUES
   $CookieExpiration = C('Plugin.CookiePop.CookieExpiration', 30); 
   $CPop= C('Plugin.CookiePop.CPop',"We use cookies just so you know");
   //ECHO THE POPUP
echo '<script type="text/javascript">
jQuery(document).ready(function($){
if (document.cookie.indexOf(\'visited=true\') == -1) {
var setDays = 1000*60*60*24*'.$CookieExpiration.';
var expires = new Date((new Date()).valueOf() + setDays);
document.cookie = "visited=true;expires=" + expires.toUTCString();
$.colorbox({width:"100%", height:"200px", inline:true, href:"#tP"});
}
$(\'button#cboxClose\').attr({
  alt: "I Accept Cookies",
  title: "I Accept Cookies"
 });
});
</script>
<div style="display:none">
<div id="tP">
<div id="tPc">
<h2 class="tP">About Cookies</h2>
<p>'.$CPop.'</p>
</div></div></div>';
}


public function Base_Render_Before($Sender) {
      $Sender->AddCssFile($this->GetResource('design/colorbox.css', FALSE, FALSE));
      $Sender->AddCssFile($this->GetResource('design/customadmin.css', FALSE, FALSE));
      $Sender->AddJsFile($this->GetResource('js/jquery.colorbox-min.js', FALSE, FALSE));
   }   

//Add cleditor and ButtonBar editors to the form
public function PluginController_Render_Before($Sender) {
      $Sender->AddCssFile('buttonbar.css', 'plugins/ButtonBar');
      $Sender->AddJsFile('buttonbar.js', 'plugins/ButtonBar');
      $Sender->AddCssFile('jquery.cleditor.css', 'plugins/cleditor');
      $Sender->AddJsFile('jquery.cleditor'.(Debug() ? '' : '.min').'.js', 'plugins/cleditor', $Options);
      
   }
   public function PluginController_CookiePop_Create($Sender) {

      $Sender->Title('CookiePop Plugin');
      $Sender->AddSideMenu('plugin/CookiePop');

      $Sender->Form = new Gdn_Form();
      
    
      $this->Dispatch($Sender, $Sender->RequestArgs);
   }
   public function Controller_Index($Sender) {
   
      $Sender->Permission('Vanilla.Settings.Manage');
      
      $Sender->SetData('PluginDescription',$this->GetPluginKey('Description'));
		
		$Validation = new Gdn_Validation();
      $ConfigurationModel = new Gdn_ConfigurationModel($Validation);
      $ConfigurationModel->SetField(array(
         'Plugin.CookiePop.CookieExpiration'     => 30,
         'Plugin.CookiePop.CPop'     => '<your message here>'
      ));

      $Sender->Form->SetModel($ConfigurationModel);

      if ($Sender->Form->AuthenticatedPostBack() === FALSE) {
         $Sender->Form->SetData($ConfigurationModel->Data);
		} else {
         $ConfigurationModel->Validation->ApplyRule('Plugin.CookiePop.CPop', 'Required');
		   $ConfigurationModel->Validation->ApplyRule('Plugin.CookiePop.CPop', 'Text');
         $ConfigurationModel->Validation->ApplyRule('Plugin.CookiePop.CookieExpiration', 'Required');
         $ConfigurationModel->Validation->ApplyRule('Plugin.CookiePop.CookieExpiration', 'Integer');
         
         $Saved = $Sender->Form->Save();
         if ($Saved) {
            $Sender->InformMessage(T('Your settings have been saved.'));
         }
      }
      $Sender->Render($this->GetView('CookiePop.php'));
   }

   public function Base_GetAppSettingsMenuItems_Handler($Sender) {
      $Menu = &$Sender->EventArguments['SideMenu'];
      $Menu->AddLink('Add-ons', 'CookiePop', 'plugin/CookiePop', 'Garden.Settings.Manage');
   }
   public function Setup() {
      SaveToConfig('Plugin.CookiePop.CookieExpiration', 30);
      SaveToConfig('Plugin.CookiePop.CPop', "We use cookies just so you know");
    
   }
   public function OnDisable() {
      RemoveFromConfig('Plugin.CookiePop.CookieExpiration');
      RemoveFromConfig('Plugin.CookiePop.CPop');
   }
   
}
